	// Einfaches Beispiel mit Ausgabe in einem Editor
	// Schalter und ComboBox vereinfachen die Aktionen

	import javax.swing.*;
	import java.awt.*;
	import java.awt.event.*;
	import java.sql.*;
	

	public class SqliteBsp1Company extends JFrame {

	    private JTextArea editor  = new JTextArea("");
	    private JButton bnSQL;
	    private JButton bnESC;

	    private JLabel lFormel=null;
	    private JComboBox cbSql=null;
		//private JToolBar toolbar = new JToolBar();
	    private String filename = "company.db";
	    


	    public SqliteBsp1Company() {
	        setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
	        setSize(900,400);        
	        setGUI();
	        
	        setVisible(true);
	    }
	    
	    private void setGUI() {
	      this.getContentPane().setLayout( new BorderLayout() );

	      JScrollPane sc = new JScrollPane(editor);
	      this.getContentPane().add(sc, BorderLayout.CENTER);

	      editor.setFont( new Font("Courier New", Font.BOLD,18)  );

	      JPanel panel1 = new JPanel();
	      panel1.setLayout(  new GridBagLayout() );
	      
	      bnSQL = new JButton("Starte SQL");
	      bnESC = new JButton("Ende");
	      bnSQL.setFont( new Font("Arial", Font.BOLD,18)  );


	      bnSQL.addActionListener(new java.awt.event.ActionListener() {
	        public void actionPerformed(ActionEvent e) {
	          bnSQL_Click();
	        }
	      });
	      bnESC.addActionListener(new java.awt.event.ActionListener() {
	        public void actionPerformed(ActionEvent e) {
	          bnESC_Click();
	        }
	      });
	        
	      
	      
	      lFormel = new JLabel("SQL-Befehl");
	      lFormel.setFont( new Font("Arial", Font.BOLD,18) );
	      panel1.add(lFormel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
	              ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(20,20,0,0), 0, 6));

	      String sTable="employee";
	        // ComboBox mit Eingabe
	      String[] items = new String[4];
	      items[0] = "SELECT *  FROM  employee";
	      items[1] = "SELECT lastname, firstname, street, zipcode, city, country FROM employee";
	      items[2] = "SELECT *  FROM  department";
	      items[3] = "SELECT *  FROM  employee  WHERE MONTHLYSALARY  >1000.0";
	    
	      cbSql = new JComboBox(items);
	      cbSql.setFont( new Font("Arial", Font.PLAIN,18) );
	      panel1.add(cbSql,   new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
	              ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(20,40,0,20), 00, 0));
	      cbSql.setEditable(true);
	      
	      panel1.add(bnSQL, new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
	              ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(20,20,0,0), 0, 6));
	      
	      this.getContentPane().add(panel1, BorderLayout.NORTH);
	      
	    }  // setGUI

	    private void bnESC_Click() {
	         System.exit(0);        
	    }

	    private Connection connect2DB(String filename) {
	    	Connection connection = null;  
	        try      {  
	            Class.forName("org.sqlite.JDBC");  
	            connection = DriverManager.getConnection("jdbc:sqlite:"+filename);	            
	        } 
	        catch (Exception e)       {  
	        	System.out.println(e.toString());
	        	Basis.Error(e.toString(),"Fehler");	
	            e.printStackTrace();  
	            connection = null;  
	        }
	       return connection;
	    }

	    public void bnSQL_Click()  {   // throws Exception  {
	        // Verbindung zur Datenbank, Auslese Variablen
	      Connection cn = connect2DB("d:\\progs\\eclipse\\JDBC1_2018\\"+filename);
	      if (cn==null) {
	    	  System.out.println("Fehler beim connect");
	    	  Basis.Error("Fehler beim connect","Fehler");
	    	  return;
	      }
	      
	      int ii=0;
	      if (ii==0) {
	    	 //return;
	      }
	      
	      Statement  st = null;
	      ResultSet  rs = null;
	      
	      editor.setText("Anfang\n");
	      try {
	        st =  cn.createStatement();
	        
	        String sql = (String) cbSql.getSelectedItem();
	        		
	        rs = st.executeQuery( sql );

	        // Get meta data:
	        ResultSetMetaData rsmd = rs.getMetaData();
	        int i, AnzCols;
	        AnzCols = rsmd.getColumnCount();
	        // Ausgabe der Tabelle:
	        // Oberste Zeile
	        
	        String s="";
	        for( i=0; i<AnzCols; i++ ) {
	          s=s+ "+-----------------" ;
	        }
	        s+= "+\n";
	        editor.append(s);
	        
	        s="";
	        for( i=1; i<=AnzCols; i++ ) {   // Attention: first column with 1 instead of 0
	          s=s+ "| " + extendStringToN( 16,rsmd.getColumnName( i ) ) ;
	        }
	        s=s+ "|\n" ;
	        editor.append(s);
	        
	        s="";
	        for( i=0; i<AnzCols; i++ ) {
	          s=s+  "+-----------------" ;
	        }
	        s=s+ "+\n";
	        editor.append(s);
	        
	        
	          // Schleife ber alle Tupel
	        while( rs.next() ) {
	          s="";
	          for( i=1; i<=AnzCols; i++ ) { // Attention: first column with 1 instead of 0
	            s=s+ "| " + extendStringToN( 16,rs.getString( i ) ) ;
	          }
	          s=s+ "|\n" ;  // Tupel-Ende
	         
	          editor.append(s);
	        }
	        
	        // Unterste Zeile
	        s="";
	        for( i=0; i<AnzCols; i++ ) {
	          s=s+ "+-----------------" ;
	        }
	        s=s+ "+\n" ;
	        editor.append(s);
	        
	      } catch( Exception ex ) {
	    	  Basis.Error(ex.toString(),"Fehler");
	        System.out.println( ex );
	      } finally {
	        try { if( null != rs ) rs.close(); } catch( Exception ex ) {}
	       // try { if( null != st ) ((Connection) st).close(); } catch( Exception ex ) {}
	        try { if( null != cn ) cn.close(); } catch( Exception ex ) {}
	      }
	    }     // sql


	// Extend String to length of 14 characters
	  private static final String extendStringToN( int iWantLen, String s )   {
	    if( null == s ) s = "";
	    while ( s.length() < iWantLen ) {
	      s += " ";
	    }
	    if( s.length() > iWantLen )
	        return s.substring( 0, iWantLen );
	    else
	        return s;
	  }

	    public static void main(String[] args) {
	    	SqliteBsp1Company frame = new SqliteBsp1Company();
	       
	    }
	    
	}
